<?php
/*
Plugin Name: LinkLaunder SEO - Basic
Plugin Script: linklaunder.php
Plugin URI: http://www.linklaunder.com
Description: Automated link-building system that works for you 24/7, totally free!
Version: 0.86
License: GPL
Author: LinkLaunder.com

Author URI: http://www.linklaunder.com 
cf http://mattread.com/projects/wp-plugins/installer-the-plugin/
Min WP Version: 1.5
Max WP Version: 2.6.2
Update Server: http://www.linklaunder.com/download


=== RELEASE NOTES ===

2008-11-30 - v0.86 	
2008-11-23 - v0.85 	F: Bugfixing the error code communication.
2008-10-25 - v0.81 	+: Communicating error code as well as status text.
2008-07-25 - v0.8 	+: Not storing error messages in local database.
2008-07-25 - v0.7	F: Fixed bug with local data storage
					+: Optimized plugin to store data locally, reducing communication needs
2008-07-25 - v0.6	F: Added additional security to the plugin
2008-07-25 - v0.5	+: Server now returns several suggestions, and uses the most valid
2008-07-21 - v0.4	F: Communication functions updated
2008-07-21 - v0.3	+: Added webservice communication with the central server
2008-07-20 - v0.2	+: Added tags and category reporting and assigning in the client and server
2008-07-10 - v0.1	+: Initial Wordpress version, based on original Proof Of Concept-script

Legend:
- : Removal of feature
+ : Adding of a feature
F : Bugfix

*/





/*  Copyright 2008  Linklaunder.com  (email : contact@linklaunder.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
    
    This plugin uses the NuSOAP - Web Services Toolkit for PHP, more details can be found here:
    
	http://sourceforge.net/projects/nusoap/

*/

if (preg_match('#'.basename(__FILE__) .'#', $_SERVER['PHP_SELF'])) { 
	die('Permission denied');
}
$llversion = "0.86";


include_once(dirname(__FILE__).'/nusoap.php'); // Loading the NuSOAP library

function linklaunder_install () { // Database setup. Runs first time plugin is activated
	global $wpdb;
	$table_name = $wpdb->prefix . "linklaunder";
//	if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
	$sql = "CREATE TABLE " . $table_name . " (
		time timestamp,
		id mediumint(9) NOT NULL AUTO_INCREMENT,
		postrefid mediumint(9) NOT NULL,
		link text NOT NULL,
		UNIQUE KEY id (id)
		);";
	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	dbDelta($sql);
	add_option("linklaunder_db_version", $version); // Setting the version in the options
//	}

}



// ------------------



function linklaunder_css() {
  if (is_feed())
    return ''; // Do not return css data if return data is for a RSS feed

  echo <<<END
<!-- Stylesheet for 'LinkLaunder.com ' plugin -->
<style type="text/css">
#linklaunderbox{
	background: #f3f3f3;
	padding-top:5px;
	padding-bottom:5px;
	font-size: 90%;
	padding: .5em 10px;
	border: 1px solid #ddd;

	}
</style>
END;
}


function linklaunder_filter($content) {
	if (is_single()) {//only display or assign if it is viewed in single post view - no pages allowed.
		global $wpdb;
		$postid=get_the_id(); //the id of the current post we are viewing
		$wpdb->show_errors();
		$table=$wpdb->prefix.'linklaunder';
		$linkinfo = $wpdb->get_row("SELECT * FROM $table where postrefid = '$postid'", ARRAY_A);
		if ($linkinfo){ //Link is already indexed and assigned, show from local database
			$content = $content .'<div id="linklaunderbox">'.$linkinfo['link']."</div>";
		}
		else { //Link is not indexed or not assigned, commit to core server		
			// GATHERING INFORMATION ABOUT THE POST
			$anchor=the_title("", "", false); //The title of the post
			$url=get_permalink(); // The permalink to the post
			$input=get_the_content();
			$excerpt=substr($input,0,150); // The first 150 characters of the post

			//Getting the categories for the post as a string
			foreach((get_the_category()) as $category) { 
		 	   $categories .= $category->cat_name . ','; 
			} 
			//Getting the tags for the post as a string
			$posttags = get_the_tags();
			if ($posttags) {
				foreach($posttags as $tag) {
					$tags .= $tag->name . ','; 
				}
			}
		
		    $username = get_option( 'll_username' ); // Getting the linklaunder.com username from the options table	
		    $password = get_option( 'll_password' ); // Getting the linklaunder.com password from the options table		    

			$wsdl="http://linklaunder.com/webservice/server.php?wsdl"; //The link to the webservice
			
			$client=new nusoap_client($wsdl, 'wdsl');  // Setting up the conversation.
	
			$param=array( //The values to be submitted to the webservice
			'username'=>$username,
			'password'=>$password,
			'anchor'=>$anchor,
			'url'=>$url,
			'id'=>$postid,
			'categories'=>$categories,
			'tags'=>$tags,
			'excerpt'=>$excerpt,
			'version'=>$llversion,
			); 

			if ($localdebug) {	
				$a = $client->call('LinkLaunder', $param); //The actual call to the webservice	
				$err = $client->getError();
				if ($err) {
	   				echo '<h2>Constructor error</h2><pre>' . $err . '</pre>';
				} 		
				if ($client->fault) {
					echo '<h2>Fault</h2><pre>'; print_r($result); echo '</pre>';
				} else {
					$err = $client->getError();
					if ($err) {
					echo '<h2>Error</h2><pre>' . $err . '</pre>';
					} else {
						echo '<h2>Result</h2><pre>'; print_r($result); echo '</pre>';
					}
				} 
				var_dump($a);
				echo "a:$a<br>";
				$splitter='_-=##=-_';	
				print_r($a);				
			}
			list($statuscode,$statustext) =explode($splitter,$a);
			$content="code:$statuscode, wdslstatus:$statustext".$content;
			
			if ($wdslstatus<>'') { //if the return answer is different from empty, insert result into local db
						// Remember to escape the content ($field1 = $wpdb->escape("Andy Peatling");)  
						//from http://apeatling.wordpress.com/2008/06/25/prepare-dont-escape/
						
						// AND DISPLAY IT!!!			
			
			}

			if ($wdslreturn<>'') { // If the return answer is not an error message, it can be stored locally
				$content = $content . $status.'<div id="linklaunderbox">'. $wdslreturn."</div>".$wsdlstatus; //Adding the link to the end of the post.			
			$now = gmdate("Y-m-d H:i:s", time());	
 			if  (substr($wdslreturn, 0, 5)<>'Error') { // Only store data if there are no errors... 
				$wpdb->query( $wpdb->prepare( "INSERT INTO $table( time, postrefid, link ) VALUES ( %s, %d, %s )", $now, $postid, $wdslreturn )); 	//Storing the data locally.
			}

			}
			
		
		}
	}
	return $content; //Return $content no matter what
}


function linklaunder_admin_menu() {
  if (function_exists('add_submenu_page')) {
    add_options_page('LinkLaunder SEO', 'LinkLaunder SEO', 8, basename(__FILE__), 'linklaunder_admin_options');

  }
}




function linklaunder_admin_options(){

    // variables for the field and option names 
    $opt_name = 'll_username';
    $data_field_name = 'll_username';


    $opt_name2 = 'll_password';
    $data_field_name2 = 'll_password';
    
    
    $hidden_field_name = 'mt_submit_hidden';

    // Read in existing option value from database
    $opt_val = get_option( $opt_name );
    $opt_val2 = get_option( $opt_name2 );
    
    // See if the user has posted us some information
    // If they did, this hidden field will be set to 'Y'
    if( $_POST[ $hidden_field_name ] == 'Y' ) {
        // Read their posted value
        $opt_val = $_POST[ $data_field_name ];
        $opt_val2 = $_POST[ $data_field_name2 ];
        // Save the posted value in the database
        update_option( $opt_name, $opt_val );
        update_option( $opt_name2, $opt_val2 );
        // Put an options updated message on the screen

?>
<div class="updated"><p><strong><?php _e('Options saved.', 'll_options_saved' ); ?></strong></p></div>
<?php

    }

    // Now display the options editing screen

    echo '<div class="wrap">';

    // header

    echo "<h2>" . __( 'Linklaunder options', 'll_options_header' ) . "</h2>";
 echo "<h3>" . __( 'Username and password', 'll_options_useroptions' ) . "</h3>";
    // options form
    
    ?>

<form name="form1" method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">
<input type="hidden" name="<?php echo $hidden_field_name; ?>" value="Y">

<p><?php _e("Username:", 'll_username' ); ?> 
<input type="text" name="<?php echo $data_field_name; ?>" value="<?php echo $opt_val; ?>" size="20">
</p>


<p><?php _e("Password:", 'll_password' ); ?> 
<input type="text" name="<?php echo $data_field_name2; ?>" value="<?php echo $opt_val2; ?>" size="20">
</p>

<p class="submit">
<input type="submit" name="Submit" value="<?php _e('Update Options', 'll_update_options' ) ?>" />
</p>

</form>
</div>

<?php
 
}



add_action('admin_menu', 'linklaunder_admin_menu');
add_filter('wp_head', 'linklaunder_css');
add_filter('the_content', 'linklaunder_filter');
register_activation_hook(__FILE__,'linklaunder_install');


?>